using UnityEngine;
using System.Collections;
using System.Collections.Generic;
//switches levels, calls other scripts, manages game
public class gameManager : MonoBehaviour {

	public static int levelNumber = 1;
	public static bool tutorialOver = false;
	public static bool hitPlay = true; // set to false
	
	public static bool hasWon = false;
	public static bool hasLost = false;
	
	public GameObject ground;
	public GameObject HUD;
	public GameObject endScreen;
	
	public float endTimer = 1.0f;
	
	public GUISkin scoreSkin;
	
	public GameObject endObject;
	
	Vector3 endPosition = new Vector3(450f, 0f, 0f);
	
	public playerSpawner spawner;
	public trainerSpawner trainerSpawnerScript;
	
	List<GameObject> obstaclesSpawnedList = new List<GameObject> ();
	
	bool resetMenu = false;
	public moveCam cam;
	
	void Start () 
	{
		Instantiate(endObject, endPosition, Quaternion.identity);
	}
	
	
	public void AddObjectToList ( GameObject objectToAdd )
	{
		print ( "OBJECT ADDED" );
		obstaclesSpawnedList.Add ( objectToAdd );
	}
	
	void Update () {
		
		if (hitPlay)
		{
			spawner.InitPlayer ();
			cam.ResetPosition ();
			if ( tutorialOver )
				trainerSpawnerScript.SpawnTrainer ();
			hitPlay = false;
			moveplayer.endLevel = false;
			endTimer = 1;
			hasWon = false;
			hasLost = false;
			resetMenu = false;
			moveplayer.coinCounter = 0;
				
				
			ground.GetComponent<coinSpawner>().enabled = true;
			ground.GetComponent<playerSpawner>().enabled = true;
			HUD.SetActive (true);
				
			switch (levelNumber){
				case 1: ground.GetComponent<obstacleSpawner1>().enabled = true;
						break;
				case 2: ground.GetComponent<obstacleSpawner2>().enabled = true;
						break;
				case 3: ground.GetComponent<obstacleSpawner3>().enabled = true;
						break;
				case 4: ground.GetComponent<obstacleSpawner4>().enabled = true;
						break;
				}	
		}
		
		if (moveplayer.endLevel || moveplayer.girlIsCaught)	
		{
			moveplayer.runspeed = 0;
			/*
			ground.GetComponent<coinSpawner>().enabled = false;
			ground.GetComponent<playerSpawner>().enabled = false;
			
			ground.GetComponent<obstacleSpawner1>().enabled = false;
			ground.GetComponent<obstacleSpawner2>().enabled = false;
			ground.GetComponent<obstacleSpawner3>().enabled = false;
			ground.GetComponent<obstacleSpawner4>().enabled = false;
			*/
			HUD.SetActive (false);
			
			if (endTimer <= 0){
				
				if (moveplayer.endLevel)
					hasWon = true;
				else hasLost = true;
					
				endScreen.SetActive (true);
				resetMenu = true;
				// try again button
				
			}
				
			else endTimer -= Time.deltaTime;
			
		}
		
		if ( Input.GetMouseButtonDown (0) && resetMenu )
		{
			spawner.DeletePlayer ();
			foreach ( GameObject obj in obstaclesSpawnedList )
				Destroy ( obj );
			obstaclesSpawnedList = new List<GameObject> ();
			Ray ray = Camera.main.ScreenPointToRay ( Input.mousePosition );
			RaycastHit hit = new RaycastHit ();
			if ( Physics.Raycast ( ray , out hit , 100.0f ) )
			{
				switch ( hit.collider.tag ) 
				{
					case "nextLevel": 
						levelNumber++;
						playerSpawner.level = levelNumber;
						hitPlay = true;
						resetMenu = false;
						endScreen.SetActive ( false );
						moveplayer.endLevel = false;
						moveplayer.girlIsCaught = false;
						break;
					case "tryAgain": 
						Debug.Log ("nehalhagga");
						break;
					default: break;
				}
			}
			
		}
		
	}
	
	
	
	
	
	
	void OnGUI ()
	{
		if (hasWon){
			// display score
			
			GUI.skin = scoreSkin;
			GUI.color = Color.white;
			GUI.Label(new Rect(Screen.width/2 - 200,Screen.height/2 - 100,500,500) , "Score: " + (moveplayer.coinCounter*80).ToString());
		}
		
	}
	
}