using UnityEngine;
using System.Collections;
public class moveplayer : MonoBehaviour {
	
	
	#region variables
	public GameObject slide;
	public GameObject jump;
	public GameObject double_jump;
	public GameObject fall;
	public GameObject hit;
	public GameObject hit_down;
	public GameObject caught;
	public GameObject win;
	
	BoxCollider col;
	public float timeFallen = 0.9f;
	public float hallPassTimer = 0f;
	
	Vector3 boxColSize;
	
	public float jumpspeed = 15.0f;
	public static float runspeed = 9.0f;
	public static bool bIsJumping = false;
	public static bool isSliding = false;
	public static bool girlIsCaught = false;
	public static bool endLevel = false;
	
	public static bool enableEnticer = false;
	public float timerEnticer = 0f;
	public bool disableCollider = false;
	public static bool isHitbyA = false;	
	public static bool isHitbyB = false;
	
	public static int coinCounter = 0;
	
	Vector3 startJumpPosition;
	
	public static int keycounter = 0;
	float currentJumpHeight;
	public float maxJumpHeight = 3.5f , regularJumpHeight = 1.5f;
	
	#endregion
	
	void Start () 
	{
		//initializations
		bIsJumping = false;
		isSliding = false;
		girlIsCaught = false;
		endLevel = false;
		
		enableEnticer = false;
		disableCollider = false;
		isHitbyA = false;	
		isHitbyB = false;		
		hit = GameObject.Find("hit");
		hit_down = GameObject.Find("hit_down");
		slide = GameObject.Find("slide");
		jump = GameObject.Find("jump");
		double_jump = GameObject.Find("double_jump");
		fall = GameObject.Find("fall");
		caught = GameObject.Find("caught");
		win = GameObject.Find("win");
		
		boxColSize = GetComponent<BoxCollider>().size;
		
		slide.SetActive(false);
		jump.renderer.enabled = false;
		double_jump.renderer.enabled = false;
		fall.renderer.enabled = false;
		hit.SetActive(false);
		hit_down.SetActive(false);
		caught.SetActive(false);
		win.SetActive(false);
		
		startJumpPosition = transform.position;
		currentJumpHeight = regularJumpHeight;
	
	}
	//run jump code when key pressed
	void ExecuteJump ()
	{	
		float height = transform.position.y + Time.deltaTime* jumpspeed;
		transform.position = new Vector3 ( transform.position.x , height , transform.position.z );
		
	}
	//to move player, bg, camera and trainer forward at constant speed
	void ExecuteRun() {
		if(!isHitbyA && !isHitbyB)
			transform.position = new Vector3 ( transform.position.x + Time.deltaTime*runspeed,transform.position.y , transform.position.z);
	}
	
	void Update () {
		
		ExecuteRun();
		
		#region Jump
		
		if(keycounter==0 && Input.GetKeyDown(KeyCode.W) && !bIsJumping && !isSliding  && !girlIsCaught) {
			keycounter++;
			//we got a signal to jump ... and we were not jumping
			
			//jump animations
			gameObject.renderer.enabled = false;
			double_jump.renderer.enabled = false;
			fall.renderer.enabled = false;
			jump.renderer.enabled = true;
			
			//start jumping now
			bIsJumping = true;
		}
		if ( keycounter == 1  && Input.GetKeyDown(KeyCode.W) )
		{
			keycounter++;
			currentJumpHeight = maxJumpHeight;
			// double jump animations
			jump.renderer.enabled = false;
			fall.renderer.enabled = false;
			double_jump.renderer.enabled = true;
				
		}
		
		if( bIsJumping )
		{
			ExecuteJump();
			if(transform.position.y - startJumpPosition.y > currentJumpHeight)
			{
				bIsJumping = false;
				//start falling
				jump.renderer.enabled = false;
				double_jump.renderer.enabled = false;
				gameObject.renderer.enabled = false;
				fall.renderer.enabled = true;
			}
		}
		
		if(transform.position.y < 0.3f && !isSliding && !isHitbyA && !isHitbyB)
		{
			jump.renderer.enabled = false;
			double_jump.renderer.enabled = false;
			fall.renderer.enabled = false;
			gameObject.renderer.enabled = true;
			keycounter = 0;
			currentJumpHeight = regularJumpHeight;
		}

		#endregion
		
		
		#region slide
		
		if(transform.position.y < -1.6f && !girlIsCaught){
			if(Input.GetKeyDown(KeyCode.S)){
				//if (!isSliding){
					GetComponent<BoxCollider>().size = new Vector3(boxColSize.x ,boxColSize.y * 0.5f, boxColSize.z);
					GetComponent<BoxCollider>().center = new Vector3(GetComponent<BoxCollider>().center.x, GetComponent<BoxCollider>().center.y - 0.5f, GetComponent<BoxCollider>().center.z);
				//}
				
				isSliding = true;

				gameObject.renderer.enabled = false;
				jump.renderer.enabled = false;
				double_jump.renderer.enabled = false;
				slide.SetActive(true);
				
			}
			if(Input.GetKeyUp(KeyCode.S)){
				
					GetComponent<BoxCollider>().size = boxColSize;
					GetComponent<BoxCollider>().center = new Vector3(GetComponent<BoxCollider>().center.x, GetComponent<BoxCollider>().center.y + 0.5f, GetComponent<BoxCollider>().center.z);
				
				isSliding = false;
				slide.SetActive(false);
				gameObject.renderer.enabled = true;
				
				
			}
		}
		
		#endregion
		
		fallen();
		
		#region caught
		// when the trainer catches the girl
		if(moveTrainer.readyToCatch && (isHitbyA || isHitbyB) && moveTrainer.position == 0) 
		{
			girlIsCaught = true;
			gameObject.renderer.enabled = false;
			jump.renderer.enabled = false;
			double_jump.renderer.enabled = false;
			slide.SetActive(false);
			hit_down.SetActive(false);
			hit.SetActive(false);
			
			caught.SetActive(true);
			
		}
		
		#endregion
		
		if(timerEnticer <= 0) {
			enableEnticer = false;
		}else {
			timerEnticer -= Time.deltaTime;
		}
		
		disableHit();
		
		if(endLevel) {
			gameObject.renderer.enabled = false;
			win.SetActive(true);
		}
	}// end of update()
	
	#region collider trigger
	void OnTriggerEnter ( Collider other )
	{
		switch ( other.collider.tag )
		{
			case "obstacleClassA":
				print ("Hit basic obstacle class A");
				if(!disableCollider)
					isHitbyA = true;
				break;
			
			case "obstacleClassB":
				print ("Hit basic obstacle class B");
				if(!disableCollider)
					isHitbyB = true;
				break;
			
			case "coin":
				//other.gameObject.renderer.enabled = false;
				Transform coinCollectedObject =  other.gameObject.transform.FindChild("coin_collected");
				coinCollectedObject.parent = null;
				coinCollectedObject.gameObject.SetActive ( true );
				Destroy ( other.gameObject );
				coinCounter++;
				break;
			
			case "hallPass":
				other.gameObject.renderer.enabled = false;
				hallPassTimer = 5.0f;
				//disableHit();
			break;
			
			case "magnet":
				other.gameObject.renderer.enabled = false;
				enableEnticer = true;
				timerEnticer = 5.0f;
			break;
			
			case "endObject":
				endLevel = true;
				//win.SetActive(true);
				//gameObject.renderer.enabled = false;
			break;
			
			default:
				break;
		}
	}
	
	void disableHit(){
		
		if(hallPassTimer <= 0){
			disableCollider = false;
			//hallPassTimer = 5.0f;
		}
		else {
			disableCollider = true;
			hallPassTimer -= Time.deltaTime;
		}
	}
	
	#endregion
	//when girl is fallen down
	#region fallen
	void fallen() {
		if(isHitbyA && !girlIsCaught){
			timeFallen-= Time.deltaTime;
			if(timeFallen <= 0){
				hit_down.SetActive(false);
				isHitbyA = false;
				timeFallen = 0.9f;
			}
			else {
				bIsJumping = false;
				gameObject.renderer.enabled = false;
				fall.renderer.enabled = false;	
				jump.renderer.enabled = false;
				double_jump.renderer.enabled = false;
				slide.SetActive(false);
				hit_down.SetActive(true);
			}
		}
		
		if(isHitbyB && !girlIsCaught){
			timeFallen-= Time.deltaTime;
			if(timeFallen <= 0){
				hit.SetActive(false);
				isHitbyB = false;
				timeFallen = 0.9f;
			}
			else {
				bIsJumping = false;
				gameObject.renderer.enabled = false;
				fall.renderer.enabled = false;	
				jump.renderer.enabled = false;
				double_jump.renderer.enabled = false;
				slide.SetActive(false);
				hit.SetActive(true);
			}
		}
	}
	#endregion
}